from yum.plugins import TYPE_CORE, TYPE_INTERACTIVE

requires_api_version = '2.3'
plugin_type = (TYPE_CORE, TYPE_INTERACTIVE)

def print_tuple_list(type, updates):
    len0 = len1 = 0
    updates.sort()
    for tuple in updates:
        if (len(tuple[0]) > len0): len0 = len(tuple[0])
        if (len(tuple[1]) > len1): len1 = len(tuple[1])
    if len(updates) > 0: print "\nThe following packages are %s updates:" % type
    for tuple in updates:
        print "%s %s => %s" % (tuple[0].ljust(len0), tuple[1].ljust(len1), tuple[2])

def postresolve_hook(conduit):
    ts = conduit.getTsInfo()
    rpmdb = conduit.getRpmDB()
    (relupdates, verupdates) = (list(), list())
    for tsmem in ts.getMembers():                                                                                                                      
        for po in rpmdb.searchNevra(name=tsmem.po.name, arch=tsmem.po.arch):                                                                           
            if (po.version != tsmem.po.version):
                verupdates.append((po.name, po.version, tsmem.po.version))
            elif (po.release != tsmem.po.release):
                relupdates.append((po.name+' ('+po.version+')', po.release, tsmem.po.release))
    print_tuple_list("release", relupdates)
    print_tuple_list("version", verupdates)

